#ifndef ArduinoESP_h
#define ArduinoESP_h
#include <SoftwareSerial.h>
#include <Arduino.h>

// define all baudrate support 
#define BAUD0 9600
#define BAUD1 19200
#define BAUD2 38400
#define BAUD3 57600
#define BAUD4 115200

// default time out
#define TIME_OUT 500

const long BAUD[] = {BAUD0, BAUD1, BAUD2, BAUD3, BAUD4}; 
const String HOST = "AT+CIPSTART=0,\"TCP\",\"184.106.153.149\",80\r\n";

class ArduinoESP{
  private:
    SoftwareSerial *mSerial;
    HardwareSerial *serialMonitor;
    bool AT_MODE = false;
    String response(bool debug = true);
    String getData();
    String subDataChannel(String tmp);
    String _channelID, _writeAPI, _readAPI;
    void connectThingSpeak();
    void disconnectThingSpeak();
  

  public:
    ArduinoESP(uint8_t rx, uint8_t tx);
    void begin(long baudrate);
    
    //configuration
    void beginConfig();
    void setBaudrate(long baudrate);
    void setWifi(String ssid, String password);
    void setAP(String ssid, String password);

    void getLocalIP();
	String my_LocalIP;
    void createPort(int port);

    //message
    void sendAT(String command);
    void sendData(int id, String data);
	void sendDataSerial(int id, String data);
    String getDataSerial();
	String getRawDataSerial();
	bool isDataArrive();
	int connectionID=0;
	void checkStringIPD(String tempdata2);
	bool found_http_IPD;

    // thing speak cloud 
    void setupThingSpeak(String channelID,String writeAPI,String readAPI);
    void sendDataToChannel(String value1,String value2,String value3,String value4,String value5,String value6,String value7,String value8);
    float getDataFromChannel(int field);
};

#endif
